nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Member Functions | List of all members
nxcip::CameraMediaEncoder3 Class Referenceabstract
Inheritance diagram for nxcip::CameraMediaEncoder3:

## Public Member Functions
virtual int | getConfiguredLiveStreamReader (LiveStreamConfig *config, StreamReader **reader)=0
| Returns configured stream reader, providing live data stream. Required method! More...
virtual int | getVideoFormat (CompressionType *codec, PixelFormat *pixelFormat) const =0
| Returns video format. Optional method. More...
Public Member Functions inherited from nxcip::CameraMediaEncoder2
virtual StreamReader * | getLiveStreamReader ()=0
| Returns stream reader, providing live data stream. More...
virtual int | getAudioFormat (AudioFormat *audioFormat) const =0
| Returns audio format, if audio is supported.
Public Member Functions inherited from nxcip::CameraMediaEncoder
virtual int | getMediaUrl (char *urlBuf) const =0
| Returns url of media stream as NULL-terminated utf-8 string. More...
virtual int | getResolutionList (ResolutionInfo *infoList, int *infoListCount) const =0
| Returns supported resolution list. More...
virtual int | getMaxBitrate (int *maxBitrate) const =0
| Returns maximum bitrate in Kbps. 0 is interpreted as unlimited bitrate value. More...
virtual int | setResolution (const Resolution &resolution)=0
| Change resolution on specified encoder. More...
virtual int | setFps (const float &fps, float *selectedFps)=0
virtual int | setBitrate (int bitrateKbps, int *selectedBitrateKbps)=0
Public Member Functions inherited from nxpl::PluginInterface
virtual void * | queryInterface (const nxpl::NX_GUID &interfaceID)=0
| Cast to type, specified by interfaceID. More...
virtual int | addRef () const =0
| Increment reference counter. More...
virtual int | releaseRef () const =0
| Decrement reference counter. More...

## Member Function Documentation

## ◆ getConfiguredLiveStreamReader()

virtual int nxcip::CameraMediaEncoder3::getConfiguredLiveStreamReader | ( | LiveStreamConfig * | config,
|  | StreamReader ** | reader
| ) |  |
| pure virtual

Returns configured stream reader, providing live data stream. Required method!

BaseCameraManager::nativeMediaStreamCapability should be present.

Parameters

  [in] | config |
  [out] | reader |

Returns
  nxcip::NX_NO_ERROR on success, otherwise - error code

Note
  It's possible to return both NULL as a reader and nxcip::NX_NO_ERROR as error code.
  - CameraMediaEncoder::getMediaUrl() will be used in this case.
  Using with this call setResolution(), setFps() and setBitrate() may return nxcip::NX_NOT_IMPLEMENTED

Implemented in rpi_cam::MediaEncoder.

## ◆ getVideoFormat()

virtual int nxcip::CameraMediaEncoder3::getVideoFormat | ( | CompressionType * | codec,
|  | PixelFormat * | pixelFormat
| ) |  | const
| pure virtual

Returns video format. Optional method.

Parameters

  [out] | codec |
  [out] | pixelFormat | NOTE: Uncompressed video from a camera is not supported by the Server, thus the values AV_PIX_FMT_RGB24, AV_PIX_FMT_BGRA and AV_PIX_FMT_RGBA cannot be used.

Returns
  nxcip::NX_NO_ERROR on success, otherwise - error code

See also
  nxcip::CompressionType
  nxcip::PixelFormat

Implemented in rpi_cam::MediaEncoder.

The documentation for this class was generated from the following file:

- src/camera/camera_plugin.h